/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: WeizenEGA.c
 *
 * Code generated for Simulink model 'WeizenEGA'.
 *
 * Model version                  : 1.11
 * Simulink Coder version         : 23.2 (R2023b) 01-Aug-2023
 * C/C++ source code generated on : Mon Jan 15 16:57:29 2024
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "WeizenEGA.h"
#include <math.h>
#include "rt_nonfinite.h"
#include "rtwtypes.h"
#include "WeizenEGA_private.h"

/* Block signals (default storage) */
B_WeizenEGA_T WeizenEGA_B;

/* Continuous states */
X_WeizenEGA_T WeizenEGA_X;

/* Disabled State Vector */
XDis_WeizenEGA_T WeizenEGA_XDis;

/* Block states (default storage) */
DW_WeizenEGA_T WeizenEGA_DW;

/* Real-time model */
static RT_MODEL_WeizenEGA_T WeizenEGA_M_;
RT_MODEL_WeizenEGA_T *const WeizenEGA_M = &WeizenEGA_M_;
static void rate_scheduler(void);

/*
 *         This function updates active task flag for each subrate.
 *         The function is called at model base rate, hence the
 *         generated code self-manages all its subrates.
 */
static void rate_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (WeizenEGA_M->Timing.TaskCounters.TID[2])++;
  if ((WeizenEGA_M->Timing.TaskCounters.TID[2]) > 99) {/* Sample time: [0.1s, 0.0s] */
    WeizenEGA_M->Timing.TaskCounters.TID[2] = 0;
  }
}

/*
 * This function updates continuous states using the ODE1 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE1_IntgData *id = (ODE1_IntgData *)rtsiGetSolverData(si);
  real_T *f0 = id->f[0];
  int_T i;
  int_T nXc = 1;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);
  rtsiSetdX(si, f0);
  WeizenEGA_derivatives();
  rtsiSetT(si, tnew);
  for (i = 0; i < nXc; ++i) {
    x[i] += h * f0[i];
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/* Model step function */
void WeizenEGA_step(void)
{
  if (rtmIsMajorTimeStep(WeizenEGA_M)) {
    /* set solver stop time */
    rtsiSetSolverStopTime(&WeizenEGA_M->solverInfo,
                          ((WeizenEGA_M->Timing.clockTick0+1)*
      WeizenEGA_M->Timing.stepSize0));
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(WeizenEGA_M)) {
    WeizenEGA_M->Timing.t[0] = rtsiGetT(&WeizenEGA_M->solverInfo);
  }

  {
    real_T lastTime;
    real_T rtb_Derivative;
    real_T rtb_Sum;
    real_T *lastU;
    if (rtmIsMajorTimeStep(WeizenEGA_M) &&
        WeizenEGA_M->Timing.TaskCounters.TID[2] == 0) {
      /* MATLABSystem: '<Root>/Run Switch' */
      if (WeizenEGA_DW.obj.SampleTime != WeizenEGA_P.RunSwitch_SampleTime) {
        WeizenEGA_DW.obj.SampleTime = WeizenEGA_P.RunSwitch_SampleTime;
      }

      /* MATLABSystem: '<Root>/Run Switch' */
      WeizenEGA_B.RunSwitch = readDigitalPin(2);
    }

    /* S-Function (read_HX711): '<Root>/ForceSensor' */
    read_HX711_Outputs_wrapper_cgen(&WeizenEGA_B.ForceSensor,
      &WeizenEGA_DW.ForceSensor_DSTATE, &WeizenEGA_P.ForceSensor_P1, 1,
      &WeizenEGA_P.ForceSensor_P2, 1);

    /* Sum: '<S2>/Sum' incorporates:
     *  Constant: '<S2>/Max. Fill level'
     *  DataStoreRead: '<Root>/Data Store Read'
     *  Product: '<S2>/Divide'
     *  Trigonometry: '<S2>/Cos'
     */
    rtb_Sum = WeizenEGA_B.ForceSensor / cos(WeizenEGA_DW.angle) +
      WeizenEGA_P.MaxFilllevel_Value;

    /* Gain: '<S1>/Kd' */
    WeizenEGA_B.Kd = WeizenEGA_P.Kd_Gain * rtb_Sum;

    /* Derivative: '<S1>/Derivative' */
    rtb_Derivative = WeizenEGA_M->Timing.t[0];
    if ((WeizenEGA_DW.TimeStampA >= rtb_Derivative) && (WeizenEGA_DW.TimeStampB >=
         rtb_Derivative)) {
      rtb_Derivative = 0.0;
    } else {
      lastTime = WeizenEGA_DW.TimeStampA;
      lastU = &WeizenEGA_DW.LastUAtTimeA;
      if (WeizenEGA_DW.TimeStampA < WeizenEGA_DW.TimeStampB) {
        if (WeizenEGA_DW.TimeStampB < rtb_Derivative) {
          lastTime = WeizenEGA_DW.TimeStampB;
          lastU = &WeizenEGA_DW.LastUAtTimeB;
        }
      } else if (WeizenEGA_DW.TimeStampA >= rtb_Derivative) {
        lastTime = WeizenEGA_DW.TimeStampB;
        lastU = &WeizenEGA_DW.LastUAtTimeB;
      }

      rtb_Derivative = (WeizenEGA_B.Kd - *lastU) / (rtb_Derivative - lastTime);
    }

    /* End of Derivative: '<S1>/Derivative' */

    /* Sum: '<S1>/Add' incorporates:
     *  Gain: '<S1>/Kp'
     *  Integrator: '<S1>/Integrator'
     */
    rtb_Derivative += WeizenEGA_P.Kp_Gain * rtb_Sum +
      WeizenEGA_X.Integrator_CSTATE;

    /* Saturate: '<S1>/Saturation' */
    if (rtb_Derivative > WeizenEGA_P.Saturation_UpperSat) {
      rtb_Derivative = WeizenEGA_P.Saturation_UpperSat;
    } else if (rtb_Derivative < WeizenEGA_P.Saturation_LowerSat) {
      rtb_Derivative = WeizenEGA_P.Saturation_LowerSat;
    }

    /* DataTypeConversion: '<Root>/Data Type Conversion' incorporates:
     *  Saturate: '<S1>/Saturation'
     */
    rtb_Derivative = floor(rtb_Derivative);
    if (rtIsNaN(rtb_Derivative) || rtIsInf(rtb_Derivative)) {
      rtb_Derivative = 0.0;
    } else {
      rtb_Derivative = fmod(rtb_Derivative, 65536.0);
    }

    /* DataTypeConversion: '<Root>/Data Type Conversion' */
    WeizenEGA_B.DataTypeConversion = rtb_Derivative < 0.0 ? (uint16_T)-(int16_T)
      (uint16_T)-rtb_Derivative : (uint16_T)rtb_Derivative;

    /* S-Function (drive_Steps): '<Root>/Stepper Motor' */
    drive_Steps_Outputs_wrapper_cgen(&WeizenEGA_B.RunSwitch,
      &WeizenEGA_B.DataTypeConversion, &WeizenEGA_B.StepperMotor,
      &WeizenEGA_DW.StepperMotor_DSTATE, &WeizenEGA_P.StepperMotor_P1, 1,
      &WeizenEGA_P.StepperMotor_P2, 1, &WeizenEGA_P.StepperMotor_P3, 1);

    /* Product: '<Root>/Divide' incorporates:
     *  Constant: '<Root>/Angle Per Step'
     *  DataStoreWrite: '<Root>/Data Store Write'
     */
    WeizenEGA_DW.angle = (real_T)WeizenEGA_B.StepperMotor *
      WeizenEGA_P.AnglePerStep_Value;

    /* Gain: '<S1>/Ki' */
    WeizenEGA_B.Ki = WeizenEGA_P.Ki_Gain * rtb_Sum;
  }

  if (rtmIsMajorTimeStep(WeizenEGA_M)) {
    real_T *lastU;

    /* Update for S-Function (read_HX711): '<Root>/ForceSensor' */

    /* S-Function "read_HX711_wrapper" Block: <Root>/ForceSensor */
    read_HX711_Update_wrapper_cgen(&WeizenEGA_B.ForceSensor,
      &WeizenEGA_DW.ForceSensor_DSTATE, &WeizenEGA_P.ForceSensor_P1, 1,
      &WeizenEGA_P.ForceSensor_P2, 1);

    /* Update for Derivative: '<S1>/Derivative' */
    if (WeizenEGA_DW.TimeStampA == (rtInf)) {
      WeizenEGA_DW.TimeStampA = WeizenEGA_M->Timing.t[0];
      lastU = &WeizenEGA_DW.LastUAtTimeA;
    } else if (WeizenEGA_DW.TimeStampB == (rtInf)) {
      WeizenEGA_DW.TimeStampB = WeizenEGA_M->Timing.t[0];
      lastU = &WeizenEGA_DW.LastUAtTimeB;
    } else if (WeizenEGA_DW.TimeStampA < WeizenEGA_DW.TimeStampB) {
      WeizenEGA_DW.TimeStampA = WeizenEGA_M->Timing.t[0];
      lastU = &WeizenEGA_DW.LastUAtTimeA;
    } else {
      WeizenEGA_DW.TimeStampB = WeizenEGA_M->Timing.t[0];
      lastU = &WeizenEGA_DW.LastUAtTimeB;
    }

    *lastU = WeizenEGA_B.Kd;

    /* End of Update for Derivative: '<S1>/Derivative' */

    /* Update for S-Function (drive_Steps): '<Root>/Stepper Motor' */

    /* S-Function "drive_Steps_wrapper" Block: <Root>/Stepper Motor */
    drive_Steps_Update_wrapper_cgen(&WeizenEGA_B.RunSwitch,
      &WeizenEGA_B.DataTypeConversion, &WeizenEGA_B.StepperMotor,
      &WeizenEGA_DW.StepperMotor_DSTATE, &WeizenEGA_P.StepperMotor_P1, 1,
      &WeizenEGA_P.StepperMotor_P2, 1, &WeizenEGA_P.StepperMotor_P3, 1);
  }                                    /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(WeizenEGA_M)) {
    rt_ertODEUpdateContinuousStates(&WeizenEGA_M->solverInfo);

    /* Update absolute time for base rate */
    /* The "clockTick0" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick0"
     * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
     * overflow during the application lifespan selected.
     */
    ++WeizenEGA_M->Timing.clockTick0;
    WeizenEGA_M->Timing.t[0] = rtsiGetSolverStopTime(&WeizenEGA_M->solverInfo);

    {
      /* Update absolute timer for sample time: [0.001s, 0.0s] */
      /* The "clockTick1" counts the number of times the code of this task has
       * been executed. The resolution of this integer timer is 0.001, which is the step size
       * of the task. Size of "clockTick1" ensures timer will not overflow during the
       * application lifespan selected.
       */
      WeizenEGA_M->Timing.clockTick1++;
    }

    rate_scheduler();
  }                                    /* end MajorTimeStep */
}

/* Derivatives for root system: '<Root>' */
void WeizenEGA_derivatives(void)
{
  XDot_WeizenEGA_T *_rtXdot;
  _rtXdot = ((XDot_WeizenEGA_T *) WeizenEGA_M->derivs);

  /* Derivatives for Integrator: '<S1>/Integrator' */
  _rtXdot->Integrator_CSTATE = WeizenEGA_B.Ki;
}

/* Model initialize function */
void WeizenEGA_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&WeizenEGA_M->solverInfo,
                          &WeizenEGA_M->Timing.simTimeStep);
    rtsiSetTPtr(&WeizenEGA_M->solverInfo, &rtmGetTPtr(WeizenEGA_M));
    rtsiSetStepSizePtr(&WeizenEGA_M->solverInfo, &WeizenEGA_M->Timing.stepSize0);
    rtsiSetdXPtr(&WeizenEGA_M->solverInfo, &WeizenEGA_M->derivs);
    rtsiSetContStatesPtr(&WeizenEGA_M->solverInfo, (real_T **)
                         &WeizenEGA_M->contStates);
    rtsiSetNumContStatesPtr(&WeizenEGA_M->solverInfo,
      &WeizenEGA_M->Sizes.numContStates);
    rtsiSetNumPeriodicContStatesPtr(&WeizenEGA_M->solverInfo,
      &WeizenEGA_M->Sizes.numPeriodicContStates);
    rtsiSetPeriodicContStateIndicesPtr(&WeizenEGA_M->solverInfo,
      &WeizenEGA_M->periodicContStateIndices);
    rtsiSetPeriodicContStateRangesPtr(&WeizenEGA_M->solverInfo,
      &WeizenEGA_M->periodicContStateRanges);
    rtsiSetContStateDisabledPtr(&WeizenEGA_M->solverInfo, (boolean_T**)
      &WeizenEGA_M->contStateDisabled);
    rtsiSetErrorStatusPtr(&WeizenEGA_M->solverInfo, (&rtmGetErrorStatus
      (WeizenEGA_M)));
    rtsiSetRTModelPtr(&WeizenEGA_M->solverInfo, WeizenEGA_M);
  }

  rtsiSetSimTimeStep(&WeizenEGA_M->solverInfo, MAJOR_TIME_STEP);
  WeizenEGA_M->intgData.f[0] = WeizenEGA_M->odeF[0];
  WeizenEGA_M->contStates = ((X_WeizenEGA_T *) &WeizenEGA_X);
  WeizenEGA_M->contStateDisabled = ((XDis_WeizenEGA_T *) &WeizenEGA_XDis);
  WeizenEGA_M->Timing.tStart = (0.0);
  rtsiSetSolverData(&WeizenEGA_M->solverInfo, (void *)&WeizenEGA_M->intgData);
  rtsiSetIsMinorTimeStepWithModeChange(&WeizenEGA_M->solverInfo, false);
  rtsiSetSolverName(&WeizenEGA_M->solverInfo,"ode1");
  rtmSetTPtr(WeizenEGA_M, &WeizenEGA_M->Timing.tArray[0]);
  WeizenEGA_M->Timing.stepSize0 = 0.001;

  /* Start for S-Function (read_HX711): '<Root>/ForceSensor' */

  /* S-Function Block: <Root>/ForceSensor */
  read_HX711_Start_wrapper_cgen(&WeizenEGA_DW.ForceSensor_DSTATE,
    &WeizenEGA_P.ForceSensor_P1, 1, &WeizenEGA_P.ForceSensor_P2, 1);

  /* Start for S-Function (drive_Steps): '<Root>/Stepper Motor' */

  /* S-Function Block: <Root>/Stepper Motor */
  drive_Steps_Start_wrapper_cgen(&WeizenEGA_DW.StepperMotor_DSTATE,
    &WeizenEGA_P.StepperMotor_P1, 1, &WeizenEGA_P.StepperMotor_P2, 1,
    &WeizenEGA_P.StepperMotor_P3, 1);

  /* Start for DataStoreMemory: '<Root>/Data Store Memory' */
  WeizenEGA_DW.angle = WeizenEGA_P.DataStoreMemory_InitialValue;

  /* InitializeConditions for S-Function (read_HX711): '<Root>/ForceSensor' */

  /* S-Function Block: <Root>/ForceSensor */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        WeizenEGA_DW.ForceSensor_DSTATE = initVector[0];
      }
    }
  }

  /* InitializeConditions for Integrator: '<S1>/Integrator' */
  WeizenEGA_X.Integrator_CSTATE = WeizenEGA_P.Integrator_IC;

  /* InitializeConditions for Derivative: '<S1>/Derivative' */
  WeizenEGA_DW.TimeStampA = (rtInf);
  WeizenEGA_DW.TimeStampB = (rtInf);

  /* InitializeConditions for S-Function (drive_Steps): '<Root>/Stepper Motor' */

  /* S-Function Block: <Root>/Stepper Motor */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        WeizenEGA_DW.StepperMotor_DSTATE = initVector[0];
      }
    }
  }

  /* Start for MATLABSystem: '<Root>/Run Switch' */
  WeizenEGA_DW.obj.matlabCodegenIsDeleted = false;
  WeizenEGA_DW.obj.SampleTime = WeizenEGA_P.RunSwitch_SampleTime;
  WeizenEGA_DW.obj.isInitialized = 1L;
  digitalIOSetup(2, 2.0);
  WeizenEGA_DW.obj.isSetupComplete = true;
}

/* Model terminate function */
void WeizenEGA_terminate(void)
{
  /* Terminate for MATLABSystem: '<Root>/Run Switch' */
  if (!WeizenEGA_DW.obj.matlabCodegenIsDeleted) {
    WeizenEGA_DW.obj.matlabCodegenIsDeleted = true;
  }

  /* End of Terminate for MATLABSystem: '<Root>/Run Switch' */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
