/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: WeizenEGA.h
 *
 * Code generated for Simulink model 'WeizenEGA'.
 *
 * Model version                  : 1.11
 * Simulink Coder version         : 23.2 (R2023b) 01-Aug-2023
 * C/C++ source code generated on : Mon Jan 15 16:57:29 2024
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_WeizenEGA_h_
#define RTW_HEADER_WeizenEGA_h_
#ifndef WeizenEGA_COMMON_INCLUDES_
#define WeizenEGA_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "read_HX711_cgen_wrapper.h"
#include "drive_Steps_cgen_wrapper.h"
#include "MW_arduino_digitalio.h"
#endif                                 /* WeizenEGA_COMMON_INCLUDES_ */

#include "WeizenEGA_types.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"
#include <stddef.h>
#include "MW_target_hardware_resources.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetContStateDisabled
#define rtmGetContStateDisabled(rtm)   ((rtm)->contStateDisabled)
#endif

#ifndef rtmSetContStateDisabled
#define rtmSetContStateDisabled(rtm, val) ((rtm)->contStateDisabled = (val))
#endif

#ifndef rtmGetContStates
#define rtmGetContStates(rtm)          ((rtm)->contStates)
#endif

#ifndef rtmSetContStates
#define rtmSetContStates(rtm, val)     ((rtm)->contStates = (val))
#endif

#ifndef rtmGetContTimeOutputInconsistentWithStateAtMajorStepFlag
#define rtmGetContTimeOutputInconsistentWithStateAtMajorStepFlag(rtm) ((rtm)->CTOutputIncnstWithState)
#endif

#ifndef rtmSetContTimeOutputInconsistentWithStateAtMajorStepFlag
#define rtmSetContTimeOutputInconsistentWithStateAtMajorStepFlag(rtm, val) ((rtm)->CTOutputIncnstWithState = (val))
#endif

#ifndef rtmGetDerivCacheNeedsReset
#define rtmGetDerivCacheNeedsReset(rtm) ((rtm)->derivCacheNeedsReset)
#endif

#ifndef rtmSetDerivCacheNeedsReset
#define rtmSetDerivCacheNeedsReset(rtm, val) ((rtm)->derivCacheNeedsReset = (val))
#endif

#ifndef rtmGetIntgData
#define rtmGetIntgData(rtm)            ((rtm)->intgData)
#endif

#ifndef rtmSetIntgData
#define rtmSetIntgData(rtm, val)       ((rtm)->intgData = (val))
#endif

#ifndef rtmGetOdeF
#define rtmGetOdeF(rtm)                ((rtm)->odeF)
#endif

#ifndef rtmSetOdeF
#define rtmSetOdeF(rtm, val)           ((rtm)->odeF = (val))
#endif

#ifndef rtmGetPeriodicContStateIndices
#define rtmGetPeriodicContStateIndices(rtm) ((rtm)->periodicContStateIndices)
#endif

#ifndef rtmSetPeriodicContStateIndices
#define rtmSetPeriodicContStateIndices(rtm, val) ((rtm)->periodicContStateIndices = (val))
#endif

#ifndef rtmGetPeriodicContStateRanges
#define rtmGetPeriodicContStateRanges(rtm) ((rtm)->periodicContStateRanges)
#endif

#ifndef rtmSetPeriodicContStateRanges
#define rtmSetPeriodicContStateRanges(rtm, val) ((rtm)->periodicContStateRanges = (val))
#endif

#ifndef rtmGetZCCacheNeedsReset
#define rtmGetZCCacheNeedsReset(rtm)   ((rtm)->zCCacheNeedsReset)
#endif

#ifndef rtmSetZCCacheNeedsReset
#define rtmSetZCCacheNeedsReset(rtm, val) ((rtm)->zCCacheNeedsReset = (val))
#endif

#ifndef rtmGetdX
#define rtmGetdX(rtm)                  ((rtm)->derivs)
#endif

#ifndef rtmSetdX
#define rtmSetdX(rtm, val)             ((rtm)->derivs = (val))
#endif

#ifndef rtmGetErrorStatus
#define rtmGetErrorStatus(rtm)         ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
#define rtmSetErrorStatus(rtm, val)    ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
#define rtmGetStopRequested(rtm)       ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
#define rtmSetStopRequested(rtm, val)  ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
#define rtmGetStopRequestedPtr(rtm)    (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
#define rtmGetT(rtm)                   (rtmGetTPtr((rtm))[0])
#endif

#ifndef rtmGetTPtr
#define rtmGetTPtr(rtm)                ((rtm)->Timing.t)
#endif

#ifndef rtmGetTStart
#define rtmGetTStart(rtm)              ((rtm)->Timing.tStart)
#endif

/* Block signals (default storage) */
typedef struct {
  real_T ForceSensor;                  /* '<Root>/ForceSensor' */
  real_T Kd;                           /* '<S1>/Kd' */
  real_T Ki;                           /* '<S1>/Ki' */
  uint16_T DataTypeConversion;         /* '<Root>/Data Type Conversion' */
  uint16_T StepperMotor;               /* '<Root>/Stepper Motor' */
  boolean_T RunSwitch;                 /* '<Root>/Run Switch' */
} B_WeizenEGA_T;

/* Block states (default storage) for system '<Root>' */
typedef struct {
  codertarget_arduinobase_block_T obj; /* '<Root>/Run Switch' */
  real_T ForceSensor_DSTATE;           /* '<Root>/ForceSensor' */
  real_T StepperMotor_DSTATE;          /* '<Root>/Stepper Motor' */
  real_T TimeStampA;                   /* '<S1>/Derivative' */
  real_T LastUAtTimeA;                 /* '<S1>/Derivative' */
  real_T TimeStampB;                   /* '<S1>/Derivative' */
  real_T LastUAtTimeB;                 /* '<S1>/Derivative' */
  real_T angle;                        /* '<Root>/Data Store Memory' */
} DW_WeizenEGA_T;

/* Continuous states (default storage) */
typedef struct {
  real_T Integrator_CSTATE;            /* '<S1>/Integrator' */
} X_WeizenEGA_T;

/* State derivatives (default storage) */
typedef struct {
  real_T Integrator_CSTATE;            /* '<S1>/Integrator' */
} XDot_WeizenEGA_T;

/* State disabled  */
typedef struct {
  boolean_T Integrator_CSTATE;         /* '<S1>/Integrator' */
} XDis_WeizenEGA_T;

#ifndef ODE1_INTG
#define ODE1_INTG

/* ODE1 Integration Data */
typedef struct {
  real_T *f[1];                        /* derivatives */
} ODE1_IntgData;

#endif

/* Parameters (default storage) */
struct P_WeizenEGA_T_ {
  real_T RunSwitch_SampleTime;         /* Expression: 0.1
                                        * Referenced by: '<Root>/Run Switch'
                                        */
  real_T MaxFilllevel_Value;           /* Expression: 1
                                        * Referenced by: '<S2>/Max. Fill level'
                                        */
  real_T Kp_Gain;                      /* Expression: 1
                                        * Referenced by: '<S1>/Kp'
                                        */
  real_T Integrator_IC;                /* Expression: 0
                                        * Referenced by: '<S1>/Integrator'
                                        */
  real_T Kd_Gain;                      /* Expression: 1
                                        * Referenced by: '<S1>/Kd'
                                        */
  real_T Saturation_UpperSat;          /* Expression: 10
                                        * Referenced by: '<S1>/Saturation'
                                        */
  real_T Saturation_LowerSat;          /* Expression: 0
                                        * Referenced by: '<S1>/Saturation'
                                        */
  real_T AnglePerStep_Value;           /* Expression: 1
                                        * Referenced by: '<Root>/Angle Per Step'
                                        */
  real_T Ki_Gain;                      /* Expression: 1
                                        * Referenced by: '<S1>/Ki'
                                        */
  real_T DataStoreMemory_InitialValue; /* Expression: 0
                                        * Referenced by: '<Root>/Data Store Memory'
                                        */
  uint8_T ForceSensor_P1;              /* Expression: uint8(9)
                                        * Referenced by: '<Root>/ForceSensor'
                                        */
  uint8_T ForceSensor_P2;              /* Expression: uint8(8)
                                        * Referenced by: '<Root>/ForceSensor'
                                        */
  uint8_T StepperMotor_P1;             /* Expression: uint8(4)
                                        * Referenced by: '<Root>/Stepper Motor'
                                        */
  uint8_T StepperMotor_P2;             /* Expression: uint8(3)
                                        * Referenced by: '<Root>/Stepper Motor'
                                        */
  uint8_T StepperMotor_P3;             /* Expression: uint8(5)
                                        * Referenced by: '<Root>/Stepper Motor'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_WeizenEGA_T {
  const char_T *errorStatus;
  RTWSolverInfo solverInfo;
  X_WeizenEGA_T *contStates;
  int_T *periodicContStateIndices;
  real_T *periodicContStateRanges;
  real_T *derivs;
  XDis_WeizenEGA_T *contStateDisabled;
  boolean_T zCCacheNeedsReset;
  boolean_T derivCacheNeedsReset;
  boolean_T CTOutputIncnstWithState;
  real_T odeF[1][1];
  ODE1_IntgData intgData;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    int_T numContStates;
    int_T numPeriodicContStates;
    int_T numSampTimes;
  } Sizes;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    uint32_T clockTick0;
    time_T stepSize0;
    uint32_T clockTick1;
    struct {
      uint8_T TID[3];
    } TaskCounters;

    time_T tStart;
    SimTimeStep simTimeStep;
    boolean_T stopRequestedFlag;
    time_T *t;
    time_T tArray[3];
  } Timing;
};

/* Block parameters (default storage) */
extern P_WeizenEGA_T WeizenEGA_P;

/* Block signals (default storage) */
extern B_WeizenEGA_T WeizenEGA_B;

/* Continuous states (default storage) */
extern X_WeizenEGA_T WeizenEGA_X;

/* Disabled states (default storage) */
extern XDis_WeizenEGA_T WeizenEGA_XDis;

/* Block states (default storage) */
extern DW_WeizenEGA_T WeizenEGA_DW;

/* Model entry point functions */
extern void WeizenEGA_initialize(void);
extern void WeizenEGA_step(void);
extern void WeizenEGA_terminate(void);

/* Real-time Model object */
extern RT_MODEL_WeizenEGA_T *const WeizenEGA_M;
extern volatile boolean_T stopRequested;
extern volatile boolean_T runModel;

/*-
 * These blocks were eliminated from the model due to optimizations:
 *
 * Block '<Root>/Kraft' : Unused code path elimination
 * Block '<Root>/Regelabweichung' : Unused code path elimination
 * Block '<Root>/Running' : Unused code path elimination
 * Block '<Root>/Steps' : Unused code path elimination
 * Block '<Root>/Winkel' : Unused code path elimination
 * Block '<Root>/gefahrene Steps' : Unused code path elimination
 * Block '<Root>/Data Type Conversion1' : Eliminate redundant data type conversion
 */

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'WeizenEGA'
 * '<S1>'   : 'WeizenEGA/PID-Regler'
 * '<S2>'   : 'WeizenEGA/Subsystem'
 */
#endif                                 /* RTW_HEADER_WeizenEGA_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
