/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: WeizenEGA_private.h
 *
 * Code generated for Simulink model 'WeizenEGA'.
 *
 * Model version                  : 1.11
 * Simulink Coder version         : 23.2 (R2023b) 01-Aug-2023
 * C/C++ source code generated on : Mon Jan 15 16:57:29 2024
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_WeizenEGA_private_h_
#define RTW_HEADER_WeizenEGA_private_h_
#include "rtwtypes.h"
#include "WeizenEGA_types.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"

/* Private macros used by the generated code to access rtModel */
#ifndef rtmIsMajorTimeStep
#define rtmIsMajorTimeStep(rtm)        (((rtm)->Timing.simTimeStep) == MAJOR_TIME_STEP)
#endif

#ifndef rtmIsMinorTimeStep
#define rtmIsMinorTimeStep(rtm)        (((rtm)->Timing.simTimeStep) == MINOR_TIME_STEP)
#endif

#ifndef rtmSetTPtr
#define rtmSetTPtr(rtm, val)           ((rtm)->Timing.t = (val))
#endif

#ifdef __cplusplus
#define SFB_EXTERN_C                   extern "C"
#else
#define SFB_EXTERN_C                   extern
#endif

SFB_EXTERN_C void read_HX711_Start_wrapper(real_T *xD,
  const uint8_T *SCK, const int_T p_width0,
  const uint8_T *DOUT, const int_T p_width1);
SFB_EXTERN_C void read_HX711_Outputs_wrapper(real_T *force,
  const real_T *xD,
  const uint8_T *SCK, const int_T p_width0,
  const uint8_T *DOUT, const int_T p_width1);
SFB_EXTERN_C void read_HX711_Update_wrapper(real_T *force,
  real_T *xD,
  const uint8_T *SCK, const int_T p_width0,
  const uint8_T *DOUT, const int_T p_width1);
SFB_EXTERN_C void read_HX711_Terminate_wrapper(real_T *xD,
  const uint8_T *SCK, const int_T p_width0,
  const uint8_T *DOUT, const int_T p_width1);

#undef SFB_EXTERN_C
#ifdef __cplusplus
#define SFB_EXTERN_C                   extern "C"
#else
#define SFB_EXTERN_C                   extern
#endif

SFB_EXTERN_C void drive_Steps_Start_wrapper(real_T *xD,
  const uint8_T *ENA, const int_T p_width0,
  const uint8_T *DIR, const int_T p_width1,
  const uint8_T *PUL, const int_T p_width2);
SFB_EXTERN_C void drive_Steps_Outputs_wrapper(const boolean_T *shouldStep,
  const uint16_T *stepsToDrive,
  uint16_T *stepsDriven,
  const real_T *xD,
  const uint8_T *ENA, const int_T p_width0,
  const uint8_T *DIR, const int_T p_width1,
  const uint8_T *PUL, const int_T p_width2);
SFB_EXTERN_C void drive_Steps_Update_wrapper(const boolean_T *shouldStep,
  const uint16_T *stepsToDrive,
  uint16_T *stepsDriven,
  real_T *xD,
  const uint8_T *ENA, const int_T p_width0,
  const uint8_T *DIR, const int_T p_width1,
  const uint8_T *PUL, const int_T p_width2);
SFB_EXTERN_C void drive_Steps_Terminate_wrapper(real_T *xD,
  const uint8_T *ENA, const int_T p_width0,
  const uint8_T *DIR, const int_T p_width1,
  const uint8_T *PUL, const int_T p_width2);

#undef SFB_EXTERN_C

/* private model entry point functions */
extern void WeizenEGA_derivatives(void);

#endif                                 /* RTW_HEADER_WeizenEGA_private_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
