
/*
 * Include Files
 *
 */
#if defined(MATLAB_MEX_FILE)
#include "tmwtypes.h"
#include "simstruc_types.h"
#else
#define SIMPLIFIED_RTWTYPES_COMPATIBILITY
#include "rtwtypes.h"
#undef SIMPLIFIED_RTWTYPES_COMPATIBILITY
#endif



/* %%%-SFUNWIZ_wrapper_includes_Changes_BEGIN --- EDIT HERE TO _END */
#ifndef MATLAB_MEX_FILE

#include "DM442.h"

DM442 stepper;

#endif
/* %%%-SFUNWIZ_wrapper_includes_Changes_END --- EDIT HERE TO _BEGIN */
#define u_width 1
#define u_1_width 1
#define y_width 1

/*
 * Create external references here.  
 *
 */
/* %%%-SFUNWIZ_wrapper_externs_Changes_BEGIN --- EDIT HERE TO _END */
/* extern double func(double a); */
/* %%%-SFUNWIZ_wrapper_externs_Changes_END --- EDIT HERE TO _BEGIN */

/*
 * Start function
 *
 */
void drive_Steps_Start_wrapper(real_T *xD,
			const uint8_T *ENA, const int_T p_width0,
			const uint8_T *DIR, const int_T p_width1,
			const uint8_T *PUL, const int_T p_width2)
{
/* %%%-SFUNWIZ_wrapper_Start_Changes_BEGIN --- EDIT HERE TO _END */
#ifndef MATLAB_MEX_FILE
    stepper.begin(DIR[0], ENA[0], PUL[0]);
    stepper.setDirection(RIGHT);
    stepper.setFrequency(30);
    stepper.start();
}
#endif
/* %%%-SFUNWIZ_wrapper_Start_Changes_END --- EDIT HERE TO _BEGIN */
}
/*
 * Output function
 *
 */
void drive_Steps_Outputs_wrapper(const boolean_T *shouldStep,
			const uint16_T *stepsToDrive,
			uint16_T *stepsDriven,
			const real_T *xD,
			const uint8_T *ENA, const int_T p_width0,
			const uint8_T *DIR, const int_T p_width1,
			const uint8_T *PUL, const int_T p_width2)
{
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_BEGIN --- EDIT HERE TO _END */
#ifndef MATLAB_MEX_FILE
    if(shouldStep[0]) {
        stepper.setFrequency(stepsToDrive[0]);
        stepper.driveSteps(stepsToDrive[0]);
        long steps = stepper.getSteps();
        stepsDriven[0] = steps;
    }
#endif
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_END --- EDIT HERE TO _BEGIN */
}

/*
 * Updates function
 *
 */
void drive_Steps_Update_wrapper(const boolean_T *shouldStep,
			const uint16_T *stepsToDrive,
			uint16_T *stepsDriven,
			real_T *xD,
			const uint8_T *ENA, const int_T p_width0,
			const uint8_T *DIR, const int_T p_width1,
			const uint8_T *PUL, const int_T p_width2)
{
/* %%%-SFUNWIZ_wrapper_Update_Changes_BEGIN --- EDIT HERE TO _END */
 
/* %%%-SFUNWIZ_wrapper_Update_Changes_END --- EDIT HERE TO _BEGIN */
}

