#ifndef DM442_h
#define DM442_h

#define RIGHT (bool) true
#define LEFT (bool) false

/**
	This class is only configured for the Arduino Mega 2560
	You should only use Pins: 2, 3, 7, 8, 12, 13 
	Timer4 is the one which is configured, so every pwm signal on these pins are 
*/

class DM442
{
public:
	void begin(int dir, int ena, int pul);
	void start();
	void stop();

	//Use the defines for setting the direction
	void setDirection(bool direction);
	void setFrequency(int stepsPerSecond);
	void setDutyCycle(int percent);

	void resetSteps();

	void singleStep();
	void driveSteps(int steps);

	long getSteps();

private:
	int dir; //Direction-Pin address
	int ena; //Enable-Pin address
	int pul; //Pulse-Pin address
	int frequency; //highs per second
	int dutyCycle; //in %
	bool running; //Motor can drive
	bool direction; //motor rotates in direction TRUE = right | FALSE = left viewed from the front 
	long steps; //positive value for right steps | negative for left steps

};

#endif